/* By:
 * Samuel S. ElyacharShuster
 *
 * There is no Copyright on this .prg, but the boss wants his mention...so...
 * Northwood Group/Ltd.
 * 633 Skokie Blvd
 * Northbrook, IL  60062-2826
 * (708) 498-4141
 *
 * With some Liberal, uh, shall I say, Idea Cloning?, from Nantucket's
 * TBDEMO.PRG
 *
 *                             And So It Goes
 *                                  SAMES
 */


#include "Inkey.ch"
#include "Setcurs.ch"
#include "Box.ch"

#define RAS_HEAD      ""
#define RAS_COL       "  "
#define SES_EDIT      1
#define SES_ADD       2

EXTERNAL N_XFETCH  // we do this because N_XFetch is in a compiled Code Block

function RaSQLTbdemo
  local cSavScr, cOldColor
  set scoreboard off                             // Anybody Use This Horror?
  N_XErrlvl(0)                                   // My Error Handling, please
  N_XLogin()
  begin sequence // In case of fire!
         n_xuse('dbm.rec',;
                "House               C     9.0  ;" + ;
                "ID                  C     9.0  ;" + ;
                "Title               C    17.0  ;" + ;
                "PHour               NI    2.0  ;" + ;
                "PMinute             NI    2.0  ;" + ;
                "PSecond             NI    2.0  ;" + ;
                "PFrames             NI    2.0  ;" + ;
                "Box                 NI    2.0  ;" + ;
                "LibLocRow           NI    2.0  ;" + ;
                "LibLocCol           NI    1.0  ;" + ;
                "SOMHour             NI    2.0  ;" + ;
                "SOMMinute           NI    2.0  ;" + ;
                "SOMSecond           NI    2.0  ;" + ;
                "SOMFrames           NI    2.0  ;" + ;
                "DBDURHour           NI    2.0  ;" + ;
                "DBDURMinute         NI    2.0  ;" + ;
                "DBDURSecond         NI    2.0  ;" + ;
                "DBDURFrames         NI    2.0  ;" + ;
                "RECDay              NI    2.0  ;" + ;
                "RECMonth            NI    2.0  ;" + ;
                "RECYear             NI    2.0  ;" + ;
                "LASTDay             NI    2.0  ;" + ;
                "LASTMonth           NI    2.0  ;" + ;
                "LASTYear            NI    2.0  ;" + ;
                "NumOfPlays          NI    2.0  ;" + ;
                "PStatus             NI    2.0  ;"   )

  recover        // BE SURE YOU LOG OUT (Most important in VAP land!)
    N_XLogout()
    quit
  end sequence
  cSavScr   := Savescreen(00,00,24,79)
  cOldColor := Setcolor("BG/B")
  N_XOrder(2)
  N_XGotoTop()
  @ 00,00,24,79 box ""  // Yeah, a Novell MUD background
  @ 02,00 say N_XRecCount()
  RasBrowse(03,06,Maxrow()-2,MaxCol()-7)
  Setcolor(cOldColor)
  Restscreen(00,00,24,79,cSavScr)
  SetPos(23,00)
  set cursor on
  N_XLogout()
  quit
return NIL

function RasBrowse(iTop,iLeft,iBot,iRight)
  local oBr, cOldColor, iOldCursor, iKey, tMore
  local iLup, oTmpCol, bTmpBlock, cTmpScr, iOrd

  /* Make the Columns */
  oBr := TBrowseDB(iTop,iLeft,iBot,iRight)

  /* This FOR/NEXT loop is the part you wanna cut and paste into
   * YOUR application.  This is the guts of the puppy */
  for iLup := 1 to N_XFCount()

    /* Now, if you're NOT doing a loop, then you DON'T need the following
     * Macro Compile thingie.... A simple
     *   oTmpCol := TBColumNew("BTFIELDNAME",{|| N_XFetch("BTFIELDNAME")})
     *   oBr:addColum(oTmpCol)
     * will do nicely for each specified field you want! */

    bTmpBlock := &( "{|| N_XFetch('"+N_XField(iLup)+"')}" )
    oTmpCol := TBColumnNew(N_XField(iLup), bTmpBlock)
    oBr:addColumn(oTmpCol)
  next

  /* Here we use the RaSkipper! */
  OBr:skipBlock := {|x| RaSkipper(x, oBr)}

  /* Use SAMES Seperators - Big FAT suckers, you CAN'T Miss */
  oBr:headSep   := RAS_HEAD
  oBr:colSep    := RAS_COL

  /* I thougt it kinda neat that in the TBDemo, that they showed the
   * Record Number... The Btrieve Record Number should be even More
   * interesting... At least I find it so */
  oTmpCol := TBColumnNew( "Rec #", {|| N_XRecno()} )
  oBr:insColumn(1,oTmpCol)
  oBr:freeze := 1  // Freeze it just like TBDemo does

  /* There is LOADS of color to play with, so let's have some fun
   * with the Record Numbers... You'll see */
  oBr:colorSpec := "B/W, N/W, G/W, R/W, BR/W, +GR/BR, +GR/B"
  for iLup := 1 to oBr:colCount
    oTmpCol := oBr:getColumn(iLup)
    if iLup == 1  // the Record Number Column
      oTmpCol:colorBlock := {|x| iif(x > 300000000, {5,5}, ;
                                 iif(x > 250000000, {4,4}, ;
                                 iif(x > 200000000, {3,3}, ;
                                                    {2,2} )))}
      oTmpCol:defColor   := {2,2}
    elseif ValType(Eval(oTmpCol:block)) == "N"
      oTmpCol:colorBlock := {|x| iif(x < 0, {4,4}, {2,2})}
    else // All the other columns
      oTmpCol:defColor   := {1, 1}
    endif
  next


  /* One Last Thing before we go!  Gotta use RaSQL's Goto TOP/BOTTOM Funcs */
  oBr:goBottomBlock := {|| N_XGotobot() }
  oBr:goTopBlock    := {|| N_XGototop() }

  Setcolor("W/W")
  @ iTop,iLeft clear to iBot, iRight

  /* Now if we're gonna draw a shadow, let's draw an Intelegent one! */
  cTmpScr := Savescreen(iBot+1,iLeft+2,iBot+1,iRight)
  cTmpScr := Transform(cTmpScr,Replicate("X"+Chr(8),Len(cTmpScr)/2))
  Restscreen(iBot+1,iLeft+2,iBot+1,iRight,cTmpScr)
  cTmpScr := Savescreen(iTop+1,iRight+1,iBot+1,iRight+2)
  cTmpScr := Transform(cTmpScr,Replicate("X"+Chr(8),Len(cTmpScr)/2))
  Restscreen(iTop+1,iRight+1,iBot+1,iRight+2,cTmpScr)

  /* Turn off the cursor, and away we go! */
  iOldCursor := SetCursor(SC_NONE)
  tMore := .T.
  while tMore

    /* Don't Go Phrozen! */
    if oBr:colPos <= oBr:freeze
      oBr:colPos := oBr:freeze + 1
    endif

    /* Main Stabilizer */
    iKey := 0
    while iKey == 0 .and. !oBr:stable
      oBr:stabilize()
      iKey := Inkey()
    enddo

    /* If you hit a key, you DON'T do this */
    if oBr:stable
      if oBr:hitTop .or. oBr:hitBottom
        Tone(700,3)
      endif

      /* Now My Pal Troy Henikoff's Network Reassurance */
      oBr:refreshCurrent()

      /* Highlight all the way across... Why Not? */
      oBr:colorRect({oBr:rowPos,1,oBr:rowPos,oBr:colCount},{6,7})
      while !oBr:stabilize() ; enddo

      /* Now, wait for the "user" */
      iKey := Inkey(0)

      /* Change the ALL ACROSS Highlight Back */
      oBr:colorRect({oBr:rowPos,1,oBr:rowPos,oBr:colCount},{1,1})

      /* But we gota stomp this row so it goes back to the
       * colorBlock colors, and restable it otherwise on a PageUp or
       * PageDown, or Goto Top/Bottom, it momentarily leaves the row
       * ALL in color 1,1 <sigh> And yeah, it hits the disk some more
       * but while you can leave out the stabilize loop, don't leave
       * out the refreshCurrent.... And So It Goes */
      oBr:refreshCurrent()
      while !oBr:stabilize() ; enddo
    endif

    if iKey == K_ESC  // No mo, dude!
      tMore := .F.
    elseif iKey == K_F6
      iOrd := N_XOrder()
      iOrd++
      if iOrd > 3
        iOrd := 1
      endif
      N_XOrder(iOrd)
      N_XGotoTop()
      oBR:RefreshAll()
    elseif iKey == K_DOWN         // Yeah, I HATE CASE/ENDCASE!
      oBr:down()                  // This is VERY standard fair
    elseif iKey == K_PGDN         // here, so you can go ahead
      oBr:pageDown()              // and skip to the RaSkipper
    elseif iKey == K_CTRL_PGDN    // Function... Down There 
      oBr:goBottom()
    elseif iKey == K_UP
      oBr:up()
    elseif iKey == K_PGUP
      oBr:pageUp()
    elseif iKey == K_CTRL_PGUP
      oBr:goTop()
    elseif iKey == K_RIGHT
      oBr:right()
    elseif iKey == K_LEFT
      oBr:left()
    elseif iKey == K_HOME
      oBr:home()
    elseif iKey == K_END
      oBr:end()
    elseif iKey == K_CTRL_LEFT
      oBr:panLeft()
    elseif iKey == K_CTRL_RIGHT
      oBr:panRight()
    elseif iKey == K_CTRL_HOME
      oBr:panHome()
    elseif iKey == K_CTRL_END
      oBr:panEnd()
    elseif iKey == K_RETURN

      /* SIMPLE Getter (Into a Box, not "InLine") */
      RaGetter(SES_EDIT,oBr)
    elseif iKey == K_INS

      RaGetter(SES_ADD,oBr)
    else

      /* You were expecting Price Charles, perhaps? */
      Tone(200,1)
      Tone(300,1)
      Tone(400,1)
    endif
  enddo
  Setcursor(iOldCursor)
return NIL  // None of that Hanging return For Me, thank you

function RaSkipper(iSkipAmount, oBr)
  local iActualSkipped
  iActualSkipped := 0

  if iSkipAmount == 0 .or. N_XLastrec() == 0
    N_XSkip(0)  // Belt, Suspenders and a Sky Hook in my shorts

  elseif iSkipAmount > 0 .and. !N_XEof()
    /* Go Forward, Young Man! */
    while iActualSkipped < iSkipAmount
      N_XSkip(1)
      if N_XEof()
        N_XSkip(-1)
        exit
      endif
      iActualSkipped++
    enddo

  elseif  iSkipAmount < 0 .and. !N_XBof()
    /* Go Back */
    while iActualSkipped > iSkipAmount
      N_XSkip(-1)
      if N_XBof()
        exit
      endif
      iActualSkipped--
    enddo
  endif

return iActualSkipped

function RaGetter(iAddEdit, oBr)
  local cSavScr, cOldColor, cTmpScr, iLup
  local aRaFlds[N_XFCount()], GetList := {}

  set cursor on
  /* Foist, lets set up the screen */
  cSavScr   := Savescreen(05,10,20,71)
  cOldColor := Setcolor("+GR/R,N/W")
  @ 05,10,19,69 box B_DOUBLE+Space(1)
  cTmpScr := Savescreen(20,12,20,69)
  cTmpScr := Transform(cTmpScr,Replicate("X"+Chr(8),Len(cTmpScr)/2))
  Restscreen(20,12,20,69,cTmpScr)
  cTmpScr := Savescreen(07,70,20,71)
  cTmpScr := Transform(cTmpScr,Replicate("X"+Chr(8),Len(cTmpScr)/2))
  Restscreen(07,70,20,71,cTmpScr)

  /* Now, get the fields from the Database */
  if iAddEdit == SES_ADD
    N_XClrbuf()
  endif
  N_XScatter(aRaFlds)
  @ 07,15 say " Account No."  // Yeah, I could loose the extra spaces
  @ 08,15 say " Description"  // but this is a Demo, ya know?
  @ 09,15 say " YTD Credits"
  @ 10,15 say "  YTD Debits"
  @ 11,15 say " MTD Credits"
  @ 12,15 say "  MTD Debits"
  @ 13,15 say "   First QTR"
  @ 14,15 say "  Second QTR"
  @ 15,15 say "   Third QTR"
  @ 16,15 say "  Fourth QTR"
  @ 17,15 say "Jeff's Folly"
  if iAddEdit == SES_EDIT
    @ 07,29 say aRaFlds[1]  // It's the key and I don't want you to change it
    for iLup = 08 to 17
      @ iLup,29 get aRaFlds[iLup - 6]  // Simple, just like me! Starting at 2
    next
  else
    for iLup = 07 to 17
      @ iLup,29 get aRaFlds[iLup - 6]  // Adding? Add 'em all!
    next
  endif
  read
  if Updated()
    N_XGather(aRaFlds)
    if iAddEdit == SES_EDIT
      if !N_XUpdate()
        if N_XError() == 5
          NoDups()
        endif
      endif
    else
      if !N_XInsert()
        if N_XError() == 5
          NoDups()
        endif
      else
        oBr:refreshAll()    // We Want the current Line highlighted!
      endif
    endif
  endif
  set cursor off
  /* Now restore the screen and stuff */
  Setcolor(cOldColor)
  Restscreen(05,10,20,71,cSavScr)
return NIL


function NoDups
  local cSavScr, cOldColor
  cSavScr   := Savescreen(10,15,15,64)
  cOldColor := Setcolor("+R/N")
  @ 10,15,16,64 box ""+Space(1)
  @ 09,18 say "You Have Entered A Duplicate Account Number"
  @ 10,33 say "Tha's a NO NO!"
  @ 12,27 say "Please Press The 'ANY' Key"
  Tone(200,1)
  Tone(300,1)
  Tone(400,1)
  Inkey(0)
  Setcolor(cOldColor)
  Restscreen(10,15,15,64,cSavScr)
return NIL
